;**********************************************************
;* File Name		: HFs_lo.asm
;* Version 		: 1.2   22.12.2001 OK, hfsyn01.asm 
;* Title		: Includes fr HFSYNTH
;* 
;***********************************************************


;***** Subroutine register variables

.def	EEdrd	=r0		;result data byte
.def	EEardl	=r17		;address low to read from
.def	EEardh	=r18		;address high to read from

.def	EEdwr	=r16		;data byte to write to EEPROM
.def	EEawrl	=r17		;address low byte to write to
.def	EEawrh	=r18		;address high byte to write to



;***************************************************************************
;*
;* lo_setup / 21.12.01
;* Setup Mode 
;*
;***************************************************************************
lo_setup:
	ldi	Bits2,1
	sts	ram_setup,Bits2		; Setup Mode = 1
	ldi	r31,high(setup_txt*2)	; 
	ldi	r30,low(setup_txt*2)	
	rcall	show_line2;		; Ausgabe 2. zeile
	rcall	delay05sec;
	ldi	EEardh,high(eep_lo)	; EEProm prfen 
	ldi	EEardl,low(eep_lo)	; Wenn Adr $00 nicht 0 dann zweite lesen und nach ram_div
	rcall	EERead			; read address $0 MSB, Ret ist in EEdrd	=r0
	mov	temp,EEdrd
	cpi	temp,$ff		; Null ?
	breq	ld_def			; Ja, default nehmen 
	sts	ram_div+0,temp		; Sonst nach ram_div
	ldi	EEardh,high(eep_lo+1)	; EEProm prfen 
	ldi	EEardl,low(eep_lo+1)	; Wenn Adr $00 nicht 0 dann zweite lesen und nach ram_div
	rcall	EERead			; read address $0 MSB, Ret ist in EEdrd	=r0
	mov	temp,EEdrd
        sts	ram_div+1,temp		;
	rjmp	lo_go			; mit EEProm Werten weiter
ld_def:	lds	temp,ram_lo+0		; Bytes LO nach Teiler
        sts	ram_div+0,temp		;
	lds	temp,ram_lo+1		; 
        sts	ram_div+1,temp		;
lo_go:	ldi	Bits1,1			; 1 = Schrittweite 1 KHz, 
	sts	ram_m_ptr,Bits1		; Steuert ram_mpy 
	rcall	mpy_table		; Teiler ...
	rcall	Calc_fr			; BCD Berechnen
	rcall	Show_Lines		; LO Anzeigen
	ret
;*** lo_setup Ende


;***************************************************************************
;*
;* lo_chk_eep / 21.12.01
;* Werte fr LO aus EEP holen
;*
;***************************************************************************
lo_chk_eep:
	ldi	EEardh,high(eep_lo)	; EEProm prfen 
	ldi	EEardl,low(eep_lo)	; Wenn Adr $00 nicht 0 dann zweite lesen und nach ram_div
	rcall	EERead			; read address $0 MSB, Ret ist in EEdrd	=r0
	mov	temp,EEdrd
	cpi	temp,$ff		; Null ? ja dann Ende
	breq	lo_ch_q
	sts	ram_lo+0,temp		; Werte speichern
	ldi	EEardh,high(eep_lo+1)	; EEProm prfen 
	ldi	EEardl,low(eep_lo+1)	; Wenn Adr $00 nicht 0 dann zweite lesen und nach ram_div
	rcall	EERead			; read address $0 MSB, Ret ist in EEdrd	=r0
	sts	ram_lo+1,EEdrd		; Werte speichern		
lo_ch_q:ret

;*** lo_chk_eep Ende 

;***************************************************************************
;*
;* lo_eep_save / 21.12.01
;* Aktuelle Werte speichern, ram_div nach EEProm
;*
;***************************************************************************
lo_eep_save:
	lds	EEdwr,ram_div
	ldi	EEawrh,high(eep_lo)
	ldi	EEawrl,low(eep_lo)
	rcall	EEWrite			; mit 0 belegen
	lds	EEdwr,ram_div+1
	ldi	EEawrh,high(eep_lo+1)
	ldi	EEawrl,low(eep_lo+1)
	rcall	EEWrite			; mit 0 belegen
	ret
;*** lo_eep_save Ende


;***************************************************************************
;*
;* lo_eep_delete / 21.12.01
;* EEPRom werte auf ff setzen.
;*
;***************************************************************************
lo_eep_delete:
	ldi	EEdwr,$ff
	ldi	EEawrh,high(eep_lo)
	ldi	EEawrl,low(eep_lo)
	rcall	EEWrite			; mit 0 belegen
	ldi	EEawrh,high(eep_lo+1)
	ldi	EEawrl,low(eep_lo+1)
	rcall	EEWrite			; mit 0 belegen
	ret

;*** lo_eep_delete Ende

; Aus AVR100.ASM 
;***************************************************************************
;* 
;* EERead
;*
;***************************************************************************
EERead:
	sbic	EECR,EEWE	;if EEWE not clear
	rjmp	EERead		;    wait more
;	out	EEAR,EEard	;output address for 1200, commented out !

; the two following lines must be replaced with the line above if 1200 is used
	out 	EEARH,EEardh	;output address high for 8515
	out	EEARL,EEardl	;output address low for 8515

	sbi	EECR,EERE	;set EEPROM Read strobe
				;This instruction takes 4 clock cycles since
				;it halts the CPU for two clock cycles
	in	EEdrd,EEDR	;get data
	ret
;*** EERead Ende 

;***************************************************************************
;* 
;* EEWrite
;*
;***************************************************************************
EEWrite:
	sbic	EECR,EEWE	;if EEWE not clear
	rjmp	EEWrite		;    wait more

;	out	EEAR,EEawr	;output address for 1200, commented out !

; the two following lines must be replaced with the line above if 1200 is used
	out 	EEARH,EEawrh	;output address high for 8515
	out	EEARL,EEawrl	;output address low for 8515
		

	out	EEDR,EEdwr	;output data
	sbi 	EECR,EEMWE	;set master write enable, remove if 1200 is used	
	sbi	EECR,EEWE	;set EEPROM Write strobe
				;This instruction takes 4 clock cycles since
				;it halts the CPU for two clock cycles
	ret

;*** EEEWrite Ende