;**********************************************************
;* File Name		: Hfs_show.asm
;* Version 		: 1.2   22.12.2001 OK, hfsyn01.asm 
;* Title		: Includes fr HFSYNTH
;* 
;***********************************************************



;***************************************************************************
;*
;* ShowBCD 1.0 / 27.2.99
;* Anzeige eines BCD-Bytes= 2 BCD Zahlen auf dem LCD-Display
;* Fhrende Nullen werden unterdrckt, 1. Pos ist $02
;* bergabe des Wertes in R17
;* bergabe Position in R18
;* bergabe Dezimalpunkt in R20 
;* 
;***************************************************************************
.def		byte	=R17
.def		pos	=R18
.def		dp	=R20

ShowBCD:	ldi	R21,$0C		; LCD Control Display ein, Cursor aus
		rcall	lcd_control
		ldi	R21,$02		; LoopCounter
		mov 	R16,byte	; Kopie anlegen
		cbr	R16,$0F		; unteren Nibble lschen
		swap	R16
		cpi	Pos,$AA		; Trick f. 1. Nibble Kanal A
		brlt	trick
secbcd:		cpi	R16,$0A		; F = leerzeichen
		brlt	load
		ldi	R16,-16		; mit -16 laden da 48+ (-16) = 32 also Leerzeichen!
load:		ldi	R19,$30		; dez. 48 
		add	R16,R19		; zum Wert dazuaddieren
		ldi 	R23,$80		; RAM Adresse 1. Zeile 1. Pos
		cp	Pos,dp		; Position an Dezimalpunkt
		brne	nodp
		inc	Pos		; einen weiter nach links
nodp:		add	R23,Pos		; gewnschte Position dazu addieren
		mov 	R24,R16		; akt. Wert zum schreiben
		rcall	lcd_write	; und Anzeigen
trick:		mov 	R16,byte	; Kopie holen
		cbr	R16,$F0		; obere Nibble lschen
		inc 	Pos
		cpi	Pos,$4D		; cpi	Pos,$4C
		brsh	showende	; 
		dec	R21
		brne	secbcd
showende:	ret
; *** ShowBCD, Ende *** 

;***************************************************************************
;*
;* Show_Fr / 2.1.2000
;* Berechnet Frequenz fr Anzeige Teiler * Raster 
;* nderungen fr PLLTSA6057
;*     
;***************************************************************************
Show_Fr:ldi	R21,$0C		; LCD Control Display ein, Cursor aus
	rcall	lcd_control
	ldi	Pos,$03		; Start Position
	ldi	dp,$06		; Position Dezimal Punkt.
	lds	byte,ram_bcd+2	; Lese 1, Stelle , hier steht 00, 01 .. 05
	cpi	byte,$00	; 00 dann "_" Leerzeichen Ausgeben
	breq	two_sp		; Um die 1. Stelle kmmern wir uns selber
	ldi	Pos,$03		; Sonst als "normales"Byte behandeln
	lds	temp,ram_ddisp	; Debug Mode ? 
	cpi	temp,1
	breq	sbcdx		; 1. Byte mit ausgeben
	ldi	temp,$A0	
	add	byte,temp	; Falls 1,. = 0 dann " "
sbcdx:	rcall	ShowBCD		;
	rjmp	xxshow
two_sp:	ldi	R24,32		; lerrzeichen
        ldi	R23,$83		; Position
	rcall	lcd_write	; und Anzeigen
xxshow:	ldi	R23,$84		; Position
	rcall	lcd_write	; und Anzeigen
	ldi	Pos,$05		; 
	lds	byte,ram_bcd+3
	rcall	ShowBCD		;
	ldi	Pos,$08		; 
	lds	byte,ram_bcd+4
	rcall	ShowBCD		; 
	ldi	R23,$86		; Position DP
	ldi	R24,$2E		; 
	rcall	Lcd_write	; 
	ret
;***** Show_Fr Ende ******


;***************************************************************************
;*
;* Show_Step 1.1 / 10.12.2001
;* 
;***************************************************************************
show_step:
	ldi	fbinmsb,0		; MSB 
	ldi	fbinHH,0
	lds	fbinH,ram_mpy+0		; MSB
	lds	fbinL,ram_mpy+1		; LSB , Multiplyer
	rcall	bin2bcd32		; Wandlung nach BCD / Register R21-R18
	sts	ram_m_bcd+0,R15		; BCD Werte ( 2  / Byte)
	sts	ram_m_bcd+1,R14		; speichern 
	sts	ram_m_bcd+2,R13		; im RAM BCDRam
	sts	ram_m_bcd+3,R12
	sts	ram_m_bcd+4,R11		

	lds	byte,ram_m_bcd+2	; Lese 1, Stelle , hier steht 00, 01 oder 02
	cpi	byte,$00		; 00 dann "_" Leerzeichen Ausgeben
	breq	stp_mhz
	ldi	R24,48			; 0
	add	R24,byte
	rjmp	stp_xx
stp_mhz:
	ldi	R24,32			; lerrzeichen
stp_xx:	
	ldi	R23,$C4			; Position
	rcall	lcd_write		; und Anzeigen

	ldi	dp,$46			; Position Dezimal Punkt.
	ldi	Pos,$45			; 
	lds	byte,ram_m_bcd+3
	rcall	ShowBCD			;

	ldi	Pos,$48			; 
	lds	byte,ram_m_bcd+4
	rcall	ShowBCD			;
	
	ldi	R23,$C6			; Position DP
	ldi	R24,$2E			; 
	rcall	Lcd_write		; 

	ret
;***** Show_Step Ende ******
