;**********************************************************
;* File Name		: Hfs_6057.asm
;* Version 		: 1.2   22.12.2001 OK, hfsyn01.asm 
;* Title		: Includes fr HFSYNTH
;* 
;***********************************************************

;***************************************************************************
;*
;* SetFreq 2.0,  DH1AAD / 03.12.2001 
;* Setzt Teiler fr PLL TSA6057
;*
;***************************************************************************
SetF6057:
	cbi	SW_PORT,LED_pll_ok	; Unlock Led ein, nur Testweise , da kein Lock-Bit
	rcall	i2c_setup
	rcall	i2c_start		; I2C Start Condition

	lds	i2c_buffer,ram_db+0	; ModulAdresse lesen 
	rcall	i2c_write		; 
	
	lds	i2c_buffer,ram_db+1	; SubAdresse
	rcall	i2c_write		; 
	
	lds	i2c_buffer,ram_db+2	; DB 0
	rcall	i2c_write		; 

	lds	i2c_buffer,ram_db+3	; DB 1
	rcall	i2c_write		; 

	lds	i2c_buffer,ram_db+4	; DB 2
	rcall	i2c_write		; 

	lds	i2c_buffer,ram_db+5	; DB 3
	rcall	i2c_write		; 

	rcall	i2c_stop		; I2C Stop  Condition
	rcall 	Delay40us		; Da kein Lock-Bit, etwas warten 
	sbi	SW_PORT,LED_pll_ok	; sonst LED aus und ende
	ret

;***** SetFreq Ende ******


;***************************************************************************
;*
;* Calc_Fr, 1.0 02.01.2000
;*          2.0 12.12.2001
;* Berechnet Frequenz fr Anzeige (Teiler+ZF) * Raster 
;*     
;***************************************************************************
Calc_Fr:lds	r20,ram_ddisp		; Debug 1=DebugMode, Anzeige der VCO Frequenz
	cpi	r20,0
	breq	lo_sd			; Prfen Setup 
	; Direkte VCO Anzeige bzw. LO Anzeige
lo_disp:ldi	fbinmsb,0		; MSB 
	lds	fbinHH,ram_div+2	; Offset = 1
	lds	fbinH,ram_div+0	
	lds	fbinL,ram_div+1		; LSB 
	rjmp	bcddisp
lo_sd:	lds	r20,ram_setup		; Setup Mode ? 
	cpi	r20,1			; Ja ? 
	breq	lo_disp			; LO anzeigen
	lds	r18,ram_lo+0		; LO Byte1 MSB 
	lds	r19,ram_lo+1		; LO Byte2 LSB 
	lds	mc16uL,ram_div+1	; Teiler aus Ram lesen LSB
	lds	mc16uH,ram_div+0
	rcall	sub16			; VCO - LO 
	ldi	fbinmsb,0		; MSB 
	ldi	fbinHH,0		; Offset = 1
	mov	fbinH,r16	
	mov	fbinL,r17
bcddisp:rcall	bin2bcd32		; Wandlung nach BCD / Register R21-R18
	sts	ram_bcd+0,R15		; BCD Werte (2 / Byte)
	sts	ram_bcd+1,R14		; speichern 
	sts	ram_bcd+2,R13		; im RAM BCDRam
	sts	ram_bcd+3,R12
	sts	ram_bcd+4,R11		
	; Berechnen der PLL DatenBytes
	ldi	temp,0
	clc				; Clear Carry Flag
	lds	Bits1,ram_div+1		; Teiler aus Ram lesen LSB
	lds	Bits2,ram_div+0		; Teiler aus Ram lesen MSB
	rol	bits1			; 1 Bit nach links
	inc	bits1			; fr 1. Bit CP (ChargePump)
	sts	ram_db+2,bits1		; Datenbyte 0 speichern
	ldi	bits1,0			; f. DB2
	rol	Bits2			; zweite Byte auch schieben
	brcc	nocy3
	inc	Bits1			; Falls bertrag
nocy3:	sts	ram_db+3,Bits2		; Datenbyte 1 speichern
	adiw	bits1,2			; (65536) dazuaddieren S16
	adiw	bits1,tsa_mode		; ModeByte
	adiw	bits1,tsa_ra01		; Raster
	sts	ram_db+4,Bits1		; Datenbyte 2 speichern
	ret
;***** Calc_FrEnde ******
